import { Angulartics2, GoogleGlobalSiteTagSettings } from 'angulartics2';
export declare class GoogleGlobalSiteTagDefaults implements GoogleGlobalSiteTagSettings {
    trackingIds: any[];
    constructor();
}
export declare class Angulartics2GoogleGlobalSiteTag {
    protected angulartics2: Angulartics2;
    constructor(angulartics2: Angulartics2);
    startTracking(): void;
    /**
     * Manually track page view, see:
     *
     * https://developers.google.com/analytics/devguides/collection/gtagjs/single-page-applications#tracking_virtual_pageviews
     *
     * @param path relative url
     */
    pageTrack(path: string): void;
    /**
     * Send interactions to gtag, i.e. for event tracking in Google Analytics. See:
     *
     * https://developers.google.com/analytics/devguides/collection/gtagjs/events
     *
     * @param action associated with the event
     */
    eventTrack(action: string, properties: any): void;
    /**
     * Exception Track Event in GST. See:
     *
     * https://developers.google.com/analytics/devguides/collection/gtagjs/exceptions
     *
     */
    exceptionTrack(properties: any): void;
}
